# Coveo Pager Component (CoveoPager)

The Pager component attaches itself to a `div` element and renders widgets that allow the end user to navigate through the different result pages.

This component takes care of triggering a query with the correct result range whenever the end user selects a page or uses the navigation buttons (Previous and Next).

## Index

### Methods

- debugInfo
- disable
- enable
- getBindings
- nextPage
- previousPage
- setPage
- get

### Properties

- bind
- componentOptionsModel
- componentStateModel
- disabled
- logger
- queryController
- queryStateModel
- root
- searchInterface
- ID

### Accessors

- currentPage
- usageAnalytics

### Component Options

- enableNavigationButton
- maxNumberOfPages
- maximumNumberOfResultsFromIndex
- numberOfPages

### Constructors

- constructor

## Methods

### debugInfo

- debugInfo(): any

- Inherited from BaseComponent.debugInfo

  - Defined in ui/Base/BaseComponent.ts :41

  Return the debug info about this component.

  #### Returns any

### disable

- disable(): void

- Inherited from BaseComponent.disable

  - Defined in ui/Base/BaseComponent.ts :52

  Disable the component. Normally this means that the component will not execute handlers for the framework events (query events, for example). Components are enabled by default on creation.

  #### Returns void

### enable

- enable(): void

- Inherited from BaseComponent.enable

  - Defined in ui/Base/BaseComponent.ts :61

  Enable the component. Normally this means that the component will execute handlers for the framework events (query events, for example). Components are enabled by default on creation.

  #### Returns void

### getBindings

- getBindings(): IComponentBindings

- Inherited from Component.getBindings

  - Defined in ui/Base/Component.ts :328

  Return the bindings, or environment, for the current component.

  #### Returns IComponentBindings

### nextPage

- nextPage(): void

- - Defined in ui/Pager/Pager.ts :206

  Navigates to the next page, then executes a query.

  Also logs the `pageNext` event in the usage analytics with the new current page number as meta data.

  #### Returns void

### previousPage

- previousPage(): void

- - Defined in ui/Pager/Pager.ts :197

  Navigates to the previous page, then executes a query.

  Also logs the `pagePrevious` event in the usage analytics with the new current page number as meta data.

  #### Returns void

### setPage

- setPage(pageNumber: number, analyticCause?: IAnalyticsActionCause): void

- - Defined in ui/Pager/Pager.ts :180

  Sets the current page, then executes a query.

  Also logs an event in the usage analytics (`pageNumber` by default) with the new current page number as meta data.

  #### Parameters

  - ##### pageNumber: number

    The page number to navigate to.

  - ##### Default value analyticCause: IAnalyticsActionCause = analyticsActionCauseList.pagerNumber

    The event to log in the usage analytics.

  #### Returns void

### Static get

- get(element: HTMLElement, componentClass?: any, noThrow?: boolean): BaseComponent

- Inherited from Component.get

  - Defined in ui/Base/Component.ts :410

  Get the bound component to the given HTMLElement. Throws an assert if the HTMLElement has no component bound, unless using the noThrow argument.
  If there is multiple component bound to the current HTMLElement, you must specify the component class.

  #### Parameters

  - ##### element: HTMLElement

    HTMLElement for which to get the bound component.

  - ##### Optional componentClass: any

    Optional component class. If the HTMLElement has multiple components bound, you must specify which one you are targeting.

  - ##### Optional noThrow: boolean

    Boolean option to tell the method to not throw on error.

  #### Returns BaseComponent

## Properties

### bind

bind: ComponentEvents

Inherited from Component.bind

- Defined in ui/Base/Component.ts :270

Allows the component to bind events and execute them only when it is enabled.

type

  {Coveo.ComponentEvents}

### componentOptionsModel

componentOptionsModel: ComponentOptionsModel

Inherited from Component.componentOptionsModel

- Defined in ui/Base/Component.ts :294

Contains the state of options for different components. Mainly used by ResultLink.

### componentStateModel

componentStateModel: ComponentStateModel

Inherited from Component.componentStateModel

- Defined in ui/Base/Component.ts :282

Contains the state of different components (enabled vs disabled). Allows to get/set values. Triggers component state event when modified. Each component can listen to those events.

### disabled

disabled: boolean

Inherited from BaseComponent.disabled

- Defined in ui/Base/BaseComponent.ts :23

A disabled component will not participate in the query, or listen to ComponentEvents.

type

  {boolean}

### logger

logger: Logger

Inherited from BaseComponent.logger

- Defined in ui/Base/BaseComponent.ts :18

Allows component to log in the dev console.

### queryController

queryController: QueryController

Inherited from Component.queryController

- Defined in ui/Base/Component.ts :286

Contains the singleton that allows to trigger queries.

### queryStateModel

queryStateModel: QueryStateModel

Inherited from Component.queryStateModel

- Defined in ui/Base/Component.ts :278

Contains the state of the query. Allows to get/set values. Trigger query state event when modified. Each component can listen to those events.

### root

root: HTMLElement

Inherited from Component.root

- Defined in ui/Base/Component.ts :274

A reference to the root HTMLElement (the SearchInterface).

### searchInterface

searchInterface: SearchInterface

Inherited from Component.searchInterface

- Defined in ui/Base/Component.ts :290

A reference to the root of every component, the SearchInterface.

### Static ID

ID: string

Inherited from BaseComponent.ID

- Defined in ui/Base/BaseComponent.ts :28

The static ID that each component needs in order to be identified.
For example, SearchButton -> static ID: SearchButton -> className: CoveoSearchButton

## Accessors

### currentPage

- get (): number

- - Defined in ui/Pager/Pager.ts :154

  The current page (1-based index).

  #### Returns number

### usageAnalytics

- get (): IAnalyticsClient

- Inherited from Component.usageAnalytics

  - Defined in ui/Base/Component.ts :343

  A reference to the Analytics.client.

  #### Returns IAnalyticsClient

## Component Options

### enableNavigationButton

enableNavigationButton: boolean

- Defined in ui/Pager/Pager.ts :76

Specifies whether the Previous and Next buttons should appear at each end of the pager when appropriate.

The default value is `true`.

Default

  `true`

Markup configuration example(s) :

    data-enable-navigation-button='true'
    data-enable-navigation-button='false'

### maxNumberOfPages

maxNumberOfPages: number

- Defined in ui/Pager/Pager.ts :86

Specifies the maximum number of pages to display if enough results are available.

This property is typically set when the default number of accessible results from the index has been changed from its default value of `1000` (10 results per page X 100 `maxNumberOfPages`). Default value is `100`

deprecated

  This is a deprecated option. The `Pager` now automatically adapts itself on each new query, so you no longer need to specify a value for this option. However, if the default maximum number of accessible results value was changed on your Coveo index, you should use the `maximumNumberOfResultsFromIndex` option to specify the new value.

Markup configuration example(s) :

    data-max-number-of-pages='10'

### maximumNumberOfResultsFromIndex

maximumNumberOfResultsFromIndex: number

- Defined in ui/Pager/Pager.ts :98

Specifies the maximum number of results that the index can return for any query.

Default value is `1000` in a Coveo index.

If this value was modified in your Coveo index, you must specify the new value in this option for the Pager component to work properly

Default

  `1000`

Markup configuration example(s) :

    data-maximum-number-of-results-from-index='10'

### numberOfPages

numberOfPages: number

- Defined in ui/Pager/Pager.ts :60

Specifies how many page links to display in the pager.

Default value is `5` on a desktop computers and `3` on a mobile device. Minimum value is `1`.

Minimum

  `1`

Markup configuration example(s) :

    data-number-of-pages='10'

## Constructors

### constructor

- new Pager(element: HTMLElement, options?: IPagerOptions, bindings?: IComponentBindings): Pager

- Overwrites Component.constructor

  - Defined in ui/Pager/Pager.ts :115

  Creates a new Pager. Binds multiple query events (QueryEvents.newQuery, QueryEvents.buildingQuery, QueryEvents.querySuccess, QueryEvents.queryError and QueryEvents.noResults. Renders itself on every query success.

  #### Parameters

  - ##### element: HTMLElement

    The HTMLElement on which to instantiate the component (normally a `div`).

  - ##### Optional options: IPagerOptions

    The options for the Pager component.

  - ##### Optional bindings: IComponentBindings

    The bindings that the component requires to function normally. If not set, these will be automatically resolved (with a slower execution time).

  #### Returns Pager